Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/ntl/detail/Index.hpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/ntl/detail/Index.hpp	(revision 1526)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/ntl/detail/Index.hpp	(revision 1526)
@@ -0,0 +1,534 @@
+////////////////////////////////////////////////////////////////////////////////
+// NTL Nonstandard Template Library for C++
+// Copyright (c) 2003 by Miroslav Fidler, Tomas Rylek
+//
+// Created by Miroslav Fidler, Tomas Rylek, cxl@volny.cz
+//
+// Permission to use, copy, modify, distribute and sell this software for any 
+//     purpose is hereby granted without fee, provided that the above copyright 
+//     notice appear in all copies and that both that copyright notice and this 
+//     permission notice appear in supporting documentation.
+// The author makes no representations about the suitability of this software 
+//     for any purpose. It is provided "as is" 
+//     without express or implied warranty.
+////////////////////////////////////////////////////////////////////////////////
+
+inline void HashBase::LinkTo(int i, Link& l, int& m) const
+{
+	if(m >= 0) {
+		Link& bl = link[m];
+		l.next = m;
+		l.prev = bl.prev;
+		bl.prev = i;
+		link[l.prev].next = i;
+	}
+	else
+		m = l.prev = l.next = i;
+}
+
+inline void HashBase::Unlink(int i, Link& l, int& m)
+{
+	if(i == m) {
+		if(l.next == i) {
+			m = -1;
+			return;
+		}
+		m = l.next;
+	}
+	link[l.next].prev = l.prev;
+	link[l.prev].next = l.next;
+}
+
+inline void HashBase::Unlink(int i, Link& l)
+{
+	Unlink(i, l, hash[i] & UNSIGNED_HIBIT ? unlinked : Mapi(i));
+}
+
+inline int& HashBase::Mapi(int i) const
+{
+	return Maph(hash[i]);
+}
+
+inline int& HashBase::Maph(unsigned _hash) const
+{
+	unsigned h = _hash & ~UNSIGNED_HIBIT;
+	return map[int(((h >> 7) ^ (h >> 22) ^ (h >> 15) ^ h) & mask)];
+}
+
+inline void HashBase::DoIndex() const
+{
+	if(hash.GetCount() <= mask)
+		FinishIndex();
+	else
+		Reindex();
+}
+
+inline int HashBase::Find(unsigned _hash) const
+{
+	if(hash.GetCount() == 0) return -1;
+	if(link.GetCount() < hash.GetCount())
+		DoIndex();
+	return Maph(_hash & ~UNSIGNED_HIBIT);
+}
+
+inline int HashBase::FindNext(int i) const
+{
+	if(link.GetCount() < hash.GetCount())
+		DoIndex();
+	int q = link[i].next;
+	return q == Mapi(i) ? -1 : q;
+}
+
+inline int HashBase::FindLast(unsigned _hash) const
+{
+	if(hash.GetCount() == 0) return - 1;
+	if(link.GetCount() < hash.GetCount())
+		DoIndex();
+	int i = Find(_hash & ~UNSIGNED_HIBIT);
+	return i >= 0 ? link[i].prev : -1;
+}
+
+inline int HashBase::FindPrev(int i) const
+{
+	if(link.GetCount() < hash.GetCount())
+		DoIndex();
+	int q = link[i].prev;
+	return q == link[Mapi(i)].prev ? -1 : q;
+}
+
+inline void HashBase::Unlink(int i)
+{
+	ASSERT(!IsUnlinked(i));
+	hash[i] |= UNSIGNED_HIBIT;
+	if(i < link.GetCount()) {
+		Link& lnk = link[i];
+		Unlink(i, lnk, Mapi(i));
+		LinkTo(i, lnk, unlinked);
+	}
+}
+
+template <class T, class V, class HashFn>
+AIndex<T, V, HashFn>::AIndex(const AIndex& s, int)
+:	key(s.key, 0),
+	hash(s.hash, 0) {}
+
+template <class T, class V, class HashFn>
+void AIndex<T, V, HashFn>::Hash() {
+	for(int i = 0; i < key.GetCount(); i++)
+		hash.Add(hashfn(key[i]));
+}
+
+template <class T, class V, class HashFn>
+AIndex<T, V, HashFn>& AIndex<T, V, HashFn>::operator=(pick_ V& s) {
+	key = s;
+	hash.Clear();
+	Hash();
+	return *this;
+}
+
+template <class T, class V, class HashFn>
+AIndex<T, V, HashFn>& AIndex<T, V, HashFn>::operator<<=(const V& s) {
+	key <<= s;
+	hash.Clear();
+	Hash();
+	return *this;
+}
+
+template <class T, class V, class HashFn>
+AIndex<T, V, HashFn>::AIndex(pick_ V& s) : key(s) {
+	Hash();
+}
+
+template <class T, class V, class HashFn>
+AIndex<T, V, HashFn>::AIndex(const V& s, int) : key(s, 1) {
+	Hash();
+}
+
+template <class T, class V, class HashFn>
+void AIndex<T, V, HashFn>::Add(const T& x, unsigned _hash) {
+	key.Add(x);
+	hash.Add(_hash);
+}
+
+template <class T, class V, class HashFn>
+void AIndex<T, V, HashFn>::Add(const T& x) {
+	Add(x, hashfn(x));
+}
+
+template <class T, class V, class HashFn>
+int  AIndex<T, V, HashFn>::FindAdd(const T& _key, unsigned _hash) {
+	int i = Find(_key, _hash);
+	if(i >= 0) return i;
+	i = key.GetCount();
+	Add(_key, _hash);
+	return i;
+}
+
+template <class T, class V, class HashFn>
+int AIndex<T, V, HashFn>::Put(const T& x, unsigned _hash)
+{
+	int q = hash.Put(_hash);
+	if(q < 0) {
+		q = key.GetCount();
+		Add(x, _hash);
+	}
+	else
+		key[q] = x;
+	return q;
+}
+
+template <class T, class V, class HashFn>
+int AIndex<T, V, HashFn>::Put(const T& x)
+{
+	return Put(x, hashfn(x));
+}
+
+template <class T, class V, class HashFn>
+int  AIndex<T, V, HashFn>::FindPut(const T& _key, unsigned _hash)
+{
+	int i = Find(_key, _hash);
+	if(i >= 0) return i;
+	return Put(_key, _hash);
+}
+
+template <class T, class V, class HashFn>
+int  AIndex<T, V, HashFn>::FindPut(const T& key)
+{
+	return FindPut(key, hashfn(key));
+}
+
+template <class T, class V, class HashFn>
+inline int AIndex<T, V, HashFn>::Find(const T& x, unsigned _hash) const {
+	return Find0(x, hash.Find(_hash));
+}
+
+template <class T, class V, class HashFn>
+int AIndex<T, V, HashFn>::Find(const T& x) const {
+	return Find(x, hashfn(x));
+}
+
+template <class T, class V, class HashFn>
+int AIndex<T, V, HashFn>::FindNext(int i) const {
+	return Find0(key[i], hash.FindNext(i));
+}
+
+template <class T, class V, class HashFn>
+inline int AIndex<T, V, HashFn>::FindLast(const T& x, unsigned _hash) const {
+	return FindB(x, hash.FindLast(_hash));
+}
+
+template <class T, class V, class HashFn>
+int AIndex<T, V, HashFn>::FindLast(const T& x) const {
+	return FindLast(x, hashfn(x));
+}
+
+template <class T, class V, class HashFn>
+int AIndex<T, V, HashFn>::FindPrev(int i) const {
+	return FindB(key[i], hash.FindPrev(i));
+}
+
+template <class T, class V, class HashFn>
+int  AIndex<T, V, HashFn>::FindAdd(const T& key) {
+	return FindAdd(key, hashfn(key));
+}
+
+template <class T, class V, class HashFn>
+void  AIndex<T, V, HashFn>::Set(int i, const T& x, unsigned _hash) {
+	key[i] = x;
+	hash.Set(i, _hash);
+}
+
+template <class T, class V, class HashFn>
+void  AIndex<T, V, HashFn>::Set(int i, const T& x) {
+	Set(i, x, hashfn(x));
+}
+
+#ifdef UPP
+template <class T, class V, class HashFn>
+void AIndex<T, V, HashFn>::Serialize(Stream& s) {
+	if(s.IsLoading()) ClearIndex();
+	key.Serialize(s);
+	hash.Serialize(s);
+}
+#endif
+
+template <class T, class V, class HashFn>
+int AIndex<T, V, HashFn>::UnlinkKey(const T& k, unsigned h)
+{
+	int n = 0;
+	int q = hash.Find(h);
+	while(q >= 0) {
+		int w = q;
+		q = hash.FindNext(q);
+		if(k == key[w]) {
+			hash.Unlink(w);
+			n++;
+		}
+	}
+	return n;
+}
+
+template <class T, class V, class HashFn>
+int AIndex<T, V, HashFn>::UnlinkKey(const T& k)
+{
+	return UnlinkKey(k, hashfn(k));
+}
+
+template <class T, class V, class HashFn>
+void AIndex<T, V, HashFn>::Sweep()
+{
+	Vector<int> b = hash.GetUnlinked();
+	Sort(b);
+	Remove(b);
+}
+
+template <class T, class V, class HashFn>
+void AIndex<T, V, HashFn>::Insert(int i, const T& k, unsigned h) {
+	key.Insert(i, k);
+	hash.Insert(i, h);
+}
+
+template <class T, class V, class HashFn>
+void AIndex<T, V, HashFn>::Insert(int i, const T& k) {
+	key.Insert(i, k);
+	hash.Insert(i, hashfn(k));
+}
+
+template <class T, class V, class HashFn>
+void AIndex<T, V, HashFn>::Remove(int i)
+{
+	key.Remove(i);
+	hash.Remove(i);
+}
+
+template <class T, class V, class HashFn>
+void AIndex<T, V, HashFn>::Remove(const int *sorted_list, int count)
+{
+	key.Remove(sorted_list, count);
+	hash.Remove(sorted_list, count);
+}
+
+template <class T, class V, class HashFn>
+void AIndex<T, V, HashFn>::Remove(const Vector<int>& sl)
+{
+	Remove(sl, sl.GetCount());
+}
+
+template <class T, class V, class HashFn>
+int AIndex<T, V, HashFn>::RemoveKey(const T& k, unsigned h)
+{
+	Vector<int> rk;
+	int q = Find(k, h);
+	while(q >= 0) {
+		rk.Add(q);
+		q = FindNext(q);
+	}
+	Remove(rk);
+	return rk.GetCount();
+}
+
+template <class T, class V, class HashFn>
+int AIndex<T, V, HashFn>::RemoveKey(const T& k)
+{
+	return RemoveKey(k, hashfn(k));
+}
+
+// ------------------
+
+template <class T, class HashFn>
+void ArrayIndex<T, HashFn>::Add(T *newt, unsigned _hash) {
+	B::key.Add(newt);
+	B::hash.Add(_hash);
+}
+
+template <class T, class HashFn>
+void ArrayIndex<T, HashFn>::Add(T *newt) {
+	Add(newt, B::hashfn(*newt));
+}
+
+template <class T, class HashFn>
+void ArrayIndex<T, HashFn>::Set(int i, T *newt, unsigned _hash) {
+	B::key.Set(i, newt);
+	B::hash.Set(i, _hash);
+}
+
+template <class T, class HashFn>
+void ArrayIndex<T, HashFn>::Set(int i, T *newt) {
+	Set(i, newt, B::hashfn(*newt));
+}
+
+// --------------------
+
+template <class K, class T, class V, class HashFn>
+int AMap<K, T, V, HashFn>::FindAdd(const K& k) {
+	int i = Find(k);
+	if(i < 0) {
+		i = GetCount();
+		Add(k);
+	}
+	return i;
+}
+
+template <class K, class T, class V, class HashFn>
+int AMap<K, T, V, HashFn>::FindAdd(const K& k, const T& x) {
+	int i = Find(k);
+	if(i < 0) {
+		i = GetCount();
+		Add(k, x);
+	}
+	return i;
+}
+
+template <class K, class T, class V, class HashFn>
+int AMap<K, T, V, HashFn>::FindAddPick(const K& k, pick_ T& x) {
+	int i = Find(k);
+	if(i < 0) {
+		i = GetCount();
+		AddPick(k, x);
+	}
+	return i;
+}
+
+template <class K, class T, class V, class HashFn>
+void AMap<K, T, V, HashFn>::Put(const K& k, const T& x)
+{
+	int i = key.Put(k);
+	if(i < value.GetCount())
+		value[i] = x;
+	else {
+		ASSERT(i == value.GetCount());
+		value.Add(x);
+	}
+}
+
+template <class K, class T, class V, class HashFn>
+void AMap<K, T, V, HashFn>::PutPick(const K& k, pick_ T& x)
+{
+	int i = key.Put(k);
+	if(i < value.GetCount())
+		value[i] = x;
+	else {
+		ASSERT(i == value.GetCount());
+		value.AddPick(x);
+	}
+}
+
+template <class K, class T, class V, class HashFn>
+T&  AMap<K, T, V, HashFn>::Put(const K& k)
+{
+	int i = key.Put(k);
+	if(i < value.GetCount())
+		return value[i];
+	else {
+		ASSERT(i == value.GetCount());
+		return value.Add();
+	}
+}
+
+template <class K, class T, class V, class HashFn>
+int AMap<K, T, V, HashFn>::FindPut(const K& k)
+{
+	int i = Find(k);
+	if(i < 0) {
+		i = key.Put(k);
+		if(i >= value.GetCount()) {
+			ASSERT(i == value.GetCount());
+			i = value.GetCount();
+			value.Add();
+		}
+	}
+	return i;
+}
+
+template <class K, class T, class V, class HashFn>
+int AMap<K, T, V, HashFn>::FindPut(const K& k, const T& init)
+{
+	int i = Find(k);
+	if(i < 0) {
+		i = key.Put(k);
+		if(i >= value.GetCount()) {
+			ASSERT(i == value.GetCount());
+			i = value.GetCount();
+			value.Add(init);
+		}
+		else
+			value[i] = init;
+	}
+	return i;
+}
+
+template <class K, class T, class V, class HashFn>
+int AMap<K, T, V, HashFn>::FindPutPick(const K& k, pick_ T& init)
+{
+	int i = Find(k);
+	if(i < 0) {
+		i = key.Put(k);
+		if(i >= value.GetCount()) {
+			ASSERT(i == value.GetCount());
+			i = value.GetCount();
+			value.Add(init);
+		}
+		else
+			value[i] = init;
+	}
+	return i;
+}
+
+template <class K, class T, class V, class HashFn>
+T&  AMap<K, T, V, HashFn>::GetAdd(const K& k) {
+	int i = Find(k);
+	if(i >= 0) return value[i];
+	return Add(k);
+}
+
+template <class K, class T, class V, class HashFn>
+T&  AMap<K, T, V, HashFn>::GetAdd(const K& k, const T& x) {
+	int i = Find(k);
+	if(i >= 0) return value[i];
+	Add(k, x);
+	return value.Top();
+}
+
+template <class K, class T, class V, class HashFn>
+T&  AMap<K, T, V, HashFn>::GetAddPick(const K& k, pick_ T& x) {
+	int i = Find(k);
+	if(i >= 0) return value[i];
+	AddPick(k, x);
+	return value.Top();
+}
+
+template <class K, class T, class V, class HashFn>
+T&  AMap<K, T, V, HashFn>::GetPut(const K& k) {
+	return value[FindAdd(k)];
+}
+
+template <class K, class T, class V, class HashFn>
+T&  AMap<K, T, V, HashFn>::GetPut(const K& k, const T& x) {
+	return value[FindAdd(k, x)];
+}
+
+template <class K, class T, class V, class HashFn>
+T&  AMap<K, T, V, HashFn>::GetPutPick(const K& k, pick_ T& x) {
+	return value[FindAddPick(k, x)];
+}
+
+#ifdef UPP
+template <class K, class T, class V, class HashFn>
+void AMap<K, T, V, HashFn>::Serialize(Stream& s) {
+	int version = 0;
+	s / version % key % value;
+}
+#endif
+
+template <class K, class T, class V, class HashFn>
+int AMap<K, T, V, HashFn>::RemoveKey(const K& k)
+{
+	Vector<int> rk;
+	int q = Find(k);
+	while(q >= 0) {
+		rk.Add(q);
+		q = FindNext(q);
+	}
+	Remove(rk);
+	return rk.GetCount();
+}
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/ntl/ntl.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/ntl/ntl.h	(revision 1526)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/ntl/ntl.h	(revision 1526)
@@ -0,0 +1,76 @@
+////////////////////////////////////////////////////////////////////////////////
+// NTL Nonstandard Template Library for C++
+// Copyright (c) 2003 by Miroslav Fidler, Tomas Rylek
+//
+// Created by Miroslav Fidler, Tomas Rylek, cxl@volny.cz
+//
+// Permission to use, copy, modify, distribute and sell this software for any 
+//     purpose is hereby granted without fee, provided that the above copyright 
+//     notice appear in all copies and that both that copyright notice and this 
+//     permission notice appear in supporting documentation.
+// The author makes no representations about the suitability of this software 
+//     for any purpose. It is provided "as is" 
+//     without express or implied warranty.
+////////////////////////////////////////////////////////////////////////////////
+
+#ifndef NTL_H
+#define NTL_H
+
+#include <assert.h>
+#include <string.h>
+
+#include <new>
+
+#ifndef ASSERT
+#define ASSERT assert
+#endif
+
+#define pick_  const   // Do not beat us for this. Imagine it is #define pick_ &&
+#define _cm_   ,
+
+typedef unsigned char byte;
+
+#ifdef _MSC_VER // Solve some MSC problems...
+
+	#ifdef TYPENAME
+    	//use predefined value
+	#elif _MSC_VER < 1300
+		#define TYPENAME
+	#else
+		#define TYPENAME typename
+	#endif
+
+	// Later we might consider #pragma warning(push/pop)
+	#pragma warning(disable : 4800) //'type' : forcing value to bool 'true' or 'false'
+	#pragma warning(disable : 4786) // identifier was truncated
+	#pragma warning(disable : 4345) // POD type constructed will be default-initialized
+	#pragma warning(disable : 4675) //'function' : resolved overload was found by Koenig lookup
+
+	#define COMPILER_MSC
+
+#else
+
+	#define TYPENAME typename
+
+#endif
+
+
+#ifdef __GNUC__
+#define COMPILER_GNU
+#endif
+
+#if defined(_M_IX86) || defined(__i386__)
+	#define CPU_IA32
+#endif
+
+#include <detail/Topt.h>
+#include <detail/Vcont.h>
+#include <detail/BiCont.h>
+#include <detail/Index.h>
+#include <detail/Map.h>
+#include <detail/Algo.h>
+#include <detail/Other.h>
+#include <detail/Vcont.hpp>
+#include <detail/Index.hpp>
+
+#endif
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/ntl/Cont.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/ntl/Cont.cpp	(revision 1526)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/ntl/Cont.cpp	(revision 1526)
@@ -0,0 +1,325 @@
+////////////////////////////////////////////////////////////////////////////////
+// NTL Nonstandard Template Library for C++
+// Copyright (c) 2003 by Miroslav Fidler, Tomas Rylek
+//
+// Created by Miroslav Fidler, Tomas Rylek, cxl@volny.cz
+//
+// Permission to use, copy, modify, distribute and sell this software for any 
+//     purpose is hereby granted without fee, provided that the above copyright 
+//     notice appear in all copies and that both that copyright notice and this 
+//     permission notice appear in supporting documentation.
+// The author makes no representations about the suitability of this software 
+//     for any purpose. It is provided "as is" 
+//     without express or implied warranty.
+////////////////////////////////////////////////////////////////////////////////
+
+#include <ntl.h>
+
+#ifdef _MSC_VER
+#pragma inline_depth(255)
+#pragma optimize("t", on)
+#endif
+
+int Pow2Bound(int i)
+{
+	int n = 1;
+	while(n < i) {
+		n <<= 1;
+		ASSERT(n);
+	}
+	return n;
+}
+
+void HashBase::Free() const
+{
+	if(map)
+		NTL_RAW_FREE(map, mask + 1, sizeof(int));
+	map = NULL;
+	mask = 0;
+}
+
+void HashBase::ClearIndex() const
+{
+	link.Clear();
+	unlinked = -1;
+	Free();
+}
+
+HashBase::HashBase()
+{
+	unlinked = -1;
+	map = NULL;
+	mask = 0;
+}
+
+HashBase::HashBase(pick_ HashBase& b)
+: hash(b.hash),
+  link(b.link)
+{
+	map = b.map;
+	mask = b.mask;
+	unlinked = b.unlinked;
+	b.map = NULL;
+}
+
+void HashBase::operator=(pick_ HashBase& b)
+{
+	hash = b.hash;
+	link = b.link;
+	Free();
+	map = b.map;
+	mask = b.mask;
+	unlinked = b.unlinked;
+	b.map = NULL;
+}
+
+HashBase::HashBase(const HashBase& b, int)
+: hash(b.hash, 0)
+{
+	unlinked = -1;
+	map = NULL;
+	mask = 0;
+}
+
+void HashBase::operator<<=(const HashBase& b)
+{
+	ClearIndex();
+	hash <<= b.hash;
+}
+
+HashBase::~HashBase()
+{
+	Free();
+}
+
+inline void HashBase::LinkBefore(int i, Link& l, int bi) const
+{
+	Link& bl = link[bi];
+	l.next = bi;
+	l.prev = bl.prev;
+	bl.prev = i;
+	link[l.prev].next = i;
+}
+
+void HashBase::Trim(int count)
+{
+	ASSERT(count <= hash.GetCount() && count >= 0);
+	if(map) {
+		for(int i = count; i < link.GetCount(); i++)
+			Unlink(i, link[i]);
+		link.SetCount(count);
+	}
+	hash.SetCount(count);
+}
+
+void HashBase::Drop(int n)
+{
+	Trim(hash.GetCount() - n);
+}
+
+//inline //!! Fidler: either inline or .cpp
+void HashBase::FinishIndex() const
+{
+	int q = link.GetCount();
+	link.Reserve(hash.GetAlloc());
+	link.AddN(hash.GetCount() - q);
+	for(int i = q; i < hash.GetCount(); i++)
+		LinkTo(i, link[i], hash[i] & UNSIGNED_HIBIT ? unlinked : Mapi(i));
+}
+
+void HashBase::Reindex(int n) const
+{
+	ClearIndex();
+	Free();
+	n = ntl_max(16, Pow2Bound(n));
+	map = (int *)NTL_RAW_ALLOC(n * sizeof(int));
+	Fill(map, map + n, -1);
+	mask = n - 1;
+	FinishIndex();
+}
+
+void HashBase::Reindex() const
+{
+	Reindex(hash.GetCount());
+}
+
+void HashBase::Add(unsigned _hash)
+{
+	hash.Add(_hash & ~UNSIGNED_HIBIT);
+}
+
+void  HashBase::SetUn(int i, unsigned _hash)
+{
+	if(map) {
+		if(link.GetCount() < hash.GetCount())
+			DoIndex();
+		Link& lnk = link[i];
+		Unlink(i, lnk);
+		LinkTo(i, lnk, Maph(_hash & ~UNSIGNED_HIBIT));
+	}
+	hash[i] = _hash & ~UNSIGNED_HIBIT;
+}
+
+Vector<int> HashBase::GetUnlinked() const
+{
+	if(link.GetCount() < hash.GetCount())
+		DoIndex();
+	Vector<int> r;
+	int q = unlinked;
+	if(q >= 0) {
+		do {
+			r.Add(q);
+			q = link[q].next;
+		}
+		while(q != unlinked);
+	}
+	return r;
+}
+
+int HashBase::Put(unsigned _hash)
+{
+	if(unlinked < 0) return -1;
+	if(link.GetCount() < hash.GetCount())
+		DoIndex();
+	Link& l = link[unlinked];
+	int i = unlinked;
+	unlinked = link[unlinked].next;
+	if(i == unlinked)
+		unlinked = -1;
+	else {
+		link[l.next].prev = l.prev;
+		link[l.prev].next = l.next;
+	}
+	LinkTo(i, l, Maph(_hash & ~UNSIGNED_HIBIT));
+	hash[i] = _hash & ~UNSIGNED_HIBIT;
+	return i;
+}
+
+void HashBase::Set(int i, unsigned _hash) {
+	if(map) {
+		if(link.GetCount() < hash.GetCount())
+			DoIndex();
+		Link& lnk = link[i];
+		Unlink(i, lnk);
+		int& mi = Maph(_hash & ~UNSIGNED_HIBIT);
+		int ii = mi;
+		if(ii < 0)
+			mi = lnk.prev = lnk.next = i;
+		else
+		if(i < ii) {
+			LinkBefore(i, lnk, ii);
+			mi = i;
+		}
+		else {
+			int l = ii;
+			int h = link[ii].prev;
+			if(h - i < i - l) {
+				while(i < h) {
+					h = link[h].prev;
+				}
+				LinkBefore(i, lnk, link[h].next);
+			}
+			else {
+				l = link[l].next;
+				while(i > l && l != ii) {
+					l = link[l].next;
+				}
+				LinkBefore(i, lnk, l);
+			}
+		}
+	}
+	hash[i] = _hash & ~UNSIGNED_HIBIT;
+}
+
+void HashBase::Shrink() {
+	hash.Shrink();
+	if(Pow2Bound(hash.GetCount()) != mask + 1)
+		ClearIndex();
+	else
+		link.Shrink();
+}
+
+void HashBase::Reserve(int n)
+{
+	hash.Reserve(n);
+	link.Reserve(n);
+	n = Pow2Bound(n);
+	if(n > mask + 1)
+		Reindex(n);
+}
+
+void HashBase::Remove(int i)
+{
+	hash.Remove(i);
+	ClearIndex();
+}
+
+void HashBase::Remove(const int *sorted_list, int count)
+{
+	hash.Remove(sorted_list, count);
+	ClearIndex();
+}
+
+void HashBase::Insert(int i, unsigned _hash) {
+	hash.Insert(i, _hash & ~UNSIGNED_HIBIT);
+	ClearIndex();
+}
+
+#ifdef UPP
+void HashBase::Serialize(Stream& s) {
+	int version = 0;
+	s / version;
+	if(s.IsLoading())
+		ClearIndex();
+	hash.Serialize(s);
+}
+#endif
+
+void HashBase::Swap(HashBase& b) {
+	::Swap(hash, b.hash);
+	::Swap(link, b.link);
+	::Swap(map, b.map);
+	::Swap(mask, b.mask);
+	::Swap(unlinked, b.unlinked);
+}
+
+
+#ifdef CPU_IA32
+
+unsigned memhash(const void *ptr, size_t count)
+{
+	unsigned hash = 1234567890U;
+
+	const unsigned *ds = (unsigned *)ptr;
+	const unsigned *de = ds + (count >> 2);
+	while(ds < de)
+		hash = ((hash << 5) - hash) ^ *ds++;
+
+	const byte *s = (byte *)ds;
+	const byte *e = s + (count & 3);
+	while(s < e)
+		hash = ((hash << 5) - hash) ^ *s++;
+
+	return hash;
+}
+
+#else
+
+unsigned memhash(const void *ptr, size_t count)
+{
+	unsigned hash = 1234567890U;
+
+	const byte *s = (byte *)ptr;
+	const byte *e = s + count;
+	while(s < e)
+		hash = ((hash << 5) - hash) ^ *s++;
+
+	return hash;
+}
+
+#endif
+
+unsigned GetHashValue0(const double& d)
+{
+	return memhash(&d, sizeof(double));
+}
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/ntl/ntls.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/ntl/ntls.h	(revision 1526)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/ntl/ntls.h	(revision 1526)
@@ -0,0 +1,45 @@
+////////////////////////////////////////////////////////////////////////////////
+// NTL Nonstandard Template Library for C++
+// Copyright (c) 2003 by Miroslav Fidler, Tomas Rylek
+//
+// Created by Miroslav Fidler, Tomas Rylek, cxl@volny.cz
+//
+// Permission to use, copy, modify, distribute and sell this software for any 
+//     purpose is hereby granted without fee, provided that the above copyright 
+//     notice appear in all copies and that both that copyright notice and this 
+//     permission notice appear in supporting documentation.
+// The author makes no representations about the suitability of this software 
+//     for any purpose. It is provided "as is" 
+//     without express or implied warranty.
+////////////////////////////////////////////////////////////////////////////////
+
+#ifndef NTLS_H
+#define NTLS_H
+
+#include <string>
+#include <ntl.h>
+
+NTL_MOVEABLE(std::string)
+
+template<>
+inline unsigned GetHashValue(const std::string& x)
+{
+	return memhash(x.c_str(), x.size());
+}
+
+#ifndef NOWSTRING
+
+NTL_MOVEABLE(std::wstring)
+
+template<>
+inline unsigned GetHashValue(const std::wstring& x)
+{
+	CombineHash hash;
+	for(size_t i = 0; i != x.size(); ++i)
+		hash = hash.Put(x[i]);
+	return hash;
+}
+
+#endif
+
+#endif
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/AdjPrims.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/AdjPrims.h	(revision 1025)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/AdjPrims.h	(revision 1526)
@@ -27,5 +27,4 @@
 	class Face;
 
-
 	typedef buffer<Vertex *> vert_buffer;
 	typedef buffer<Edge *> edge_buffer;
@@ -37,13 +36,13 @@
 	extern void collectFaceLoop(Vertex *v, face_buffer& faces);
 
-	#define EDGE_BOGUS 0
-	#define EDGE_BORDER 1
-	#define EDGE_MANIFOLD 2
-	#define EDGE_NONMANIFOLD 3
+#define EDGE_BOGUS 0
+#define EDGE_BORDER 1
+#define EDGE_MANIFOLD 2
+#define EDGE_NONMANIFOLD 3
 	extern int classifyEdge(Edge *);
 
-	#define VERTEX_INTERIOR 0
-	#define VERTEX_BORDER 1
-	#define VERTEX_BORDER_ONLY 2
+#define VERTEX_INTERIOR 0
+#define VERTEX_BORDER 1
+#define VERTEX_BORDER_ONLY 2
 	extern int classifyVertex(Vertex *);
 
@@ -52,15 +51,16 @@
 	// The actual class definitions
 	//
+	////////////////////////////////////////////////////////////////////////
 
 	class VProp
 	{
-	public:
-		Vec3 color;
+		public:
+			Vec3 color;
 	};
 
 	class FProp
 	{
-	public:
-		Vec3 color;
+		public:
+			Vec3 color;
 	};
 
@@ -68,14 +68,14 @@
 	{
 		edge_buffer edge_uses;
-    
-	public:
-	#ifdef SUPPORT_VCOLOR
+
+		public:
+#ifdef SUPPORT_VCOLOR
 		VProp *props;
-	#endif
+#endif
 
 		Vertex(real x, real y, real z) : Vec3(x, y, z), edge_uses(6) {
-	#ifdef SUPPORT_VCOLOR
-		props = NULL;
-	#endif
+#ifdef SUPPORT_VCOLOR
+			props = NULL;
+#endif			
 		}
 		//
@@ -92,43 +92,44 @@
 		void remapTo(Vertex *v);
 
-		unsigned int vID;
+		// SUS
+		int vID; // this can be -1 when the vertex becomes non-valid
 	};
-
 
 	class Edge : public NPrim
 	{
-	private:
+		private:
 
-		Vertex *v1;
+			Vertex *v1;
 
-		face_buffer *face_uses;
-		Edge *twin;
+			face_buffer *face_uses;
+			Edge *twin;
 
-		Edge(Edge *twin, Vertex *org); // the twin constructor
+			Edge(Edge *twin, Vertex *org); // the twin constructor
 
-	public:
-		Edge(Vertex *, Vertex *);
-		~Edge();
+		public:
 
-		//
-		// Fundamental Edge accessors
-		//
-		Vertex *org()  { return v1;       }
-		Vertex *dest() { return twin->v1; }
-		Edge *sym()    { return twin;     }
+			Edge(Vertex *, Vertex *);
+			~Edge();
 
-		//
-		// Standard methods for all objects
-		//
-		void kill();
-		face_buffer& faceUses() { return *face_uses; }
+			//
+			// Fundamental Edge accessors
+			//
+			Vertex *org()  { return v1;       }
+			Vertex *dest() { return twin->v1; }
+			Edge *sym()    { return twin;     }
 
-		//
-		// Basic primitives for manipulating model topology
-		//
-		void linkFace(Face *);
-		void unlinkFace(Face *);
-		void remapEndpoint(Vertex *from, Vertex *to);
-		void remapTo(Edge *);
+			//
+			// Standard methods for all objects
+			//
+			void kill();
+			face_buffer& faceUses() { return *face_uses; }
+
+			//
+			// Basic primitives for manipulating model topology
+			//
+			void linkFace(Face *);
+			void unlinkFace(Face *);
+			void remapEndpoint(Vertex *from, Vertex *to);
+			void remapTo(Edge *);
 	};
 
@@ -137,9 +138,8 @@
 		Edge *edges[3];
 
-
-	public:
-	#ifdef SUPPORT_FCOLOR
+		public:
+#ifdef SUPPORT_FCOLOR
 		FProp *props;
-	#endif
+#endif
 
 		Face(Edge *, Edge *, Edge *);
@@ -148,13 +148,14 @@
 		// Basic Face accessors
 		//
-		const Vec3& vertexPos(int i) const { return *edges[i]->org(); }
-		void vertexPos(int, const Vec3&) {
+		const Vec3& vertexPos(int i) const{return *edges[i]->org();}
+
+		void vertexPos(int, const Vec3&)
+		{
 			fatal_error("Face: can't directly set vertex position.");
 		}
 
-		Vertex *vertex(int i) { return edges[i]->org(); }
-		const Vertex *vertex(int i) const { return edges[i]->org(); }
-		Edge *edge(int i)               { return edges[i];        }
-
+		Vertex *vertex(int i){return edges[i]->org();}
+		const Vertex *vertex(int i) const{return edges[i]->org();}
+		Edge *edge(int i){return edges[i];}
 
 		//
@@ -173,5 +174,5 @@
 }
 
-
 // NAUTILUS_ADJPRIMS_INCLUDED
 #endif
+
